@ECHO off
:init
SET BACKUP_DIR=..\backup7.1.1.5
SET FILE1=ILOG.Rules.Shell.dll
SET INSTALL_PATH=..\Rules for .NET Web Controls Deployment\Bin
SET INSTALLED_VERSION_35=7.1.135.5132
SET INSTALLED_VERSION_40=7.1.140.5132
SET GAC_NOT_FOUND=0
SET ERROR_INSTALL=0

REM Test if the interim fix is installed in the correct location
IF NOT EXIST "%INSTALL_PATH%\%FILE1%" GOTO incorrect_path

for /f  %%a IN ('cscript //nologo .\checkversion.vbs "%INSTALL_PATH%\%FILE1%"') DO @SET dllversion=%%a
IF NOT "%dllversion%" == "%INSTALLED_VERSION_35%" GOTO test_version2010
SET INSTALLED_PATH=2008
goto test_permission

:test_version2010
REM Verify the version installed
for /f  %%a IN ('cscript //nologo .\checkversion.vbs "%INSTALL_PATH%\%FILE1%"') DO @SET dllversion=%%a
IF NOT "%dllversion%" == "%INSTALLED_VERSION_40%" GOTO incorrect_version
SET INSTALLED_PATH=2010

:test_permission
REM Verify if the fix can be installed with permission access
ECHO "test" > "%INSTALL_PATH%\test.tmp"
IF NOT EXIST "%INSTALL_PATH%\test.tmp" GOTO incorrect_permission
DEL "%INSTALL_PATH%\test.tmp"

REM Test Visual Studio installation
SET vs2010="%PROGRAMFILES%\Microsoft Visual Studio 10.0\Common7\Tools\vsvars32.bat"
SET vs2010x86="%PROGRAMFILES(x86)%\Microsoft Visual Studio 10.0\Common7\Tools\vsvars32.bat"
SET vs2008="%PROGRAMFILES%\Microsoft Visual Studio 9.0\Common7\Tools\vsvars32.bat"
SET vs2008x86="%PROGRAMFILES(x86)%\Microsoft Visual Studio 9.0\Common7\Tools\vsvars32.bat"

REM test if GACUTIL is in the PATH
GACUTIL 2>NUL 1>NUL && SET GACUTIL_IN_PATH=1
IF "%GACUTIL_IN_PATH%" == "1" GOTO END

IF NOT EXIST %vs2010% goto test2010x86
CALL %vs2010%
GOTO END
:test2010x86
if not exist %vs2010x86% goto test2008
call %vs2010x86%
GOTO END
:test2008
if not exist %vs2008% goto test2008x86
call %vs2008%
GOTO END
:test2008x86
if not exist %vs2008x86% goto notfound
call %vs2008x86%
GOTO END
:notfound
set GAC_NOT_FOUND=1
GOTO END

:incorrect_path
ECHO Error: The interim fix cannot find Rules for .NET installation.
ECHO Action: Please move the folder IF045 to the root of the Rules for .NET installation.
SET ERROR_INSTALL=1
GOTO END

:incorrect_version
ECHO Error: The Rules for .NET version %dllversion% detected should be %INSTALLED_VERSION_35% or %INSTALLED_VERSION_40%.
ECHO Action: Please check that you are installing this fix on Rules for .NET V7.1.1.5
SET ERROR_INSTALL=1
GOTO END

:incorrect_permission
ECHO Error: You do not have enough permission to install the fix. 
ECHO Action: Please run this script as Administrator.
SET ERROR_INSTALL=1
:end
GOTO :EOF
